#ifndef _MATHH

#define _MATHH	1

const int MSIZE=4;
typedef float VEC4[4];
typedef float TMAT[4][4];
extern bool Degmode;

void zero(TMAT mat);
void iden(TMAT mat);
void transpose(TMAT tmat, TMAT mat);
void prvec(VEC4 vec);
void viewtrans(TMAT ctm);
void matmult(TMAT c,TMAT a,TMAT b);
void matcopy(TMAT b,TMAT a);

void matinv(TMAT minv, TMAT m);
void mvmult(VEC4 ans,TMAT mat,VEC4 vec);
void prmat(TMAT mat);
void vecsub(VEC4 ans,VEC4 vec1,VEC4 vec2);
void vecadd(VEC4 ans,VEC4 vec1,VEC4 vec2);
void vecscale(VEC4 ans, VEC4 vec, float sf);
void xprod(VEC4 norm,VEC4 vec1,VEC4 vec2);
float vecmag(VEC4 vec);
void dotprod(float * result,VEC4 vec1,VEC4 vec2);
void univec(VEC4 vec);                      // normalizes a 3-vector
void negvec(VEC4 ansvec,VEC4 vec);          // ansvec = -vec
void vecrot(TMAT tm,VEC4 k,float theta);    // produces matrix: Rot(k,theta)
void quatMult(VEC4 q, VEC4 q1, VEC4 q2);    // multiplies two quaternions
void quatNorm(VEC4 q);                      // normalizes quaternion
void quat_to_R(TMAT rmat, VEC4 quat);       // produces matrix corresponding to quaternion

#endif