///////////////////////////////////////////////////////////
//	FILE: main.h
///////////////////////////////////////////////////////////

#include <stdio.h>
#include <math.h>

#define TRUE 1
#define FALSE 0
#define VECSIZE 4
#define MAX_ARGS 10

const   float M_PI = 3.1415926f;
const   float DEG_RAD = M_PI/180.0f;
const   float RAD_DEG = 180.0f/M_PI;

typedef int BOOL;
typedef float FVEC[VECSIZE];
typedef int IVEC[VECSIZE];
#define STRLEN 100
typedef char STR[STRLEN];
typedef int (*PFI)();          // ptr to function that returns int
typedef void (*PFV)();         // ptr to function that returns void
typedef float GLmatrix[4][4];
typedef float Matrix[4][4];

extern int cerr(int argc, const char *argv[], char *errmsg);
extern int tprintf(const char *format, ...);

extern double Dt;          // time step
extern double Time;        // absolute time
extern double Grav;        // gravity
extern double Eps;         // coefficient of restitution
 
extern void I_inertial(TMAT i, TMAT R, TMAT IB);        // compute I in the inertial frame
extern void buildTM(TMAT tm, TMAT rotMat, VEC4 translate);   // build transformation matrix

extern int TestFlag; 







